#include s0.prc;
#include var.prc;
#include crlk.prc;
#include ers.prc;

proc(1) = cvurst(rsq,fdet);
local cvv, cv;

let cvv[5,10] =
      0.00   0.10   0.20   0.30   0.40   0.50   0.60   0.70   0.80   0.90
      3.34   3.41   3.54   3.76   4.15   4.79   5.88   7.84  12.12  25.69
      3.34   3.41   3.54   3.70   3.96   4.41   5.12   6.37   9.17  17.99
      5.70   5.79   5.98   6.38   6.99   7.97   9.63  12.60  19.03  39.62
      5.70   5.77   6.00   6.40   7.07   8.15  10.00  13.36  20.35  41.87;


if fdet==0; cvv=cvv[1:2,.];
elseif fdet==1;  cvv=cvv[1,.]|cvv[3,.];
elseif fdet==2; cvv=cvv[1,.]|cvv[4,.];
else; cvv=cvv[1,.]|cvv[5,.];
endif;

{cv}=crlk(rsq,cvv');
retp(cv);
endp;


proc(4)=urstk(y,x,rhobar,fdet,k);
local n, m, rhoest, zest, z, om, rsq, ddy,
      zone, qdy, zrho, r1, dn0, sz1, bnull,
      rr, dn, sza, balt, baltv, bnullv, st,
      st2, b1, sz2, n1, n2, b, se, sig0, res0,
      r2, siga, resa, junk, dlta;



n=rows(y);
m=cols(x);

@ est R square and lag length if auto @
if fdet==3;
{rhoest,junk}=adfers(y,2,k);
else;
{rhoest,junk}=adfers(y,fdet,k);
endif;
rhoest=rhoest[1,1];
zest=(y[1,1])|(y[2:n,.]-rhoest*y[1:n-1,.]);
z=zest~x;
{om}=s0(z,1,n,k,fdet);

dlta=inv(chol(om[2:m+1,2:m+1])')*om[2:m+1,1]/sqrt(om[1,1]);

rsq=om[1,2:m+1]*inv(om[2:m+1,2:m+1])*om[2:m+1,1]/om[1,1];

/*
"est rsq    =";;rsq;
"rho est    =";;rhoest; */
@ construct test statistic @

ddy=(y[1,1])|(y[2:n,.]-y[1:n-1,.]);
zone=ddy~x;

qdy=(y[1,1])|(y[2:n,.]-rhobar*y[1:n-1,.]);
zrho=qdy~x;


if fdet == 1;

@ estimate deterministics @
r1=eye(m+1);r1[1,1]=0;
dn0=inv(om)+(n-1)*r1*inv(om)*r1;
sz1=zone[2:n,.]'ones(n-1,1);
bnull=inv(dn0)*(inv(om)*zone[1,.]'+r1*inv(om)*sz1);

rr=r1;rr[1,1]=1-rhobar;
dn=inv(om)+(n-1)*rr*inv(om)*rr;
sza=zrho[2:n,.]'ones(n-1,1);
balt=inv(dn)*(inv(om)*zrho[1,.]'+rr*inv(om)*sza);

baltv=ones(n,1).*balt';baltv[2:n,1]=baltv[2:n,1].*(1-rhobar);
bnullv=ones(n,1).*bnull';bnullv[2:n,1]=bnullv[2:n,1].*0;

zone=zone-bnullv;
zrho=zrho-baltv;

elseif fdet==2;
r1=eye(m+1);r1[1,1]=0;
st=seqa(2,1,n-1)'ones(n-1,1);           @ sum t @
st2=seqa(2,1,n-1)'seqa(2,1,n-1);        @ sum t-squared @
b1=zeros(m+1,m+1);b1[1,1]=1;
dn0=eye(2*(m+1));
dn0[1:m+1,1:m+1]=inv(om)+(n-1)*r1*inv(om)*r1;
dn0[1:m+1,m+2:2*(m+1)]=inv(om)+r1*inv(om)*r1*st+(n-1)*r1*inv(om)*b1;
dn0[m+2:2*(m+1),1:m+1]=dn0[1:m+1,m+2:2*(m+1)]';
dn0[m+2:2*(m+1),m+2:2*(m+1)]=inv(om)+r1*inv(om)*r1*st2
   +st*r1*inv(om)*b1+st*b1*inv(om)*r1+(n-1)*b1*inv(om)*b1;
sz1=zone[2:n,.]'ones(n-1,1);
sz2=zone[2:n,.]'seqa(2,1,n-1);
n1=inv(om)*zone[1,.]'+r1*inv(om)*sz1;
n2=inv(om)*zone[1,.]'+r1*inv(om)*sz2+b1*inv(om)*sz1;
bnull=inv(dn0)*(n1|n2);

rr=eye(m+1);rr[1,1]=1-rhobar;
b1[1,1]=rhobar;
dn0=eye(2*(m+1));
dn0[1:m+1,1:m+1]=inv(om)+(n-1)*rr*inv(om)*rr;
dn0[1:m+1,m+2:2*(m+1)]=inv(om)+rr*inv(om)*rr*st+(n-1)*rr*inv(om)*b1;
dn0[m+2:2*(m+1),1:m+1]=dn0[1:m+1,m+2:2*(m+1)]';
dn0[m+2:2*(m+1),m+2:2*(m+1)]=inv(om)+rr*inv(om)*rr*st2
   +st*rr*inv(om)*b1+st*b1*inv(om)*rr+(n-1)*b1*inv(om)*b1;
sz1=zrho[2:n,.]'ones(n-1,1);
sz2=zrho[2:n,.]'seqa(2,1,n-1);
n1=(inv(om)*zrho[1,.]'+rr*inv(om)*sz1);
n2=(inv(om)*zrho[1,.]'+rr*inv(om)*sz2+b1*inv(om)*sz1);
balt=inv(dn0)*(n1|n2);


baltv=ones(n,1).*balt';
baltv[2:n,1]=baltv[2:n,1].*(1-rhobar)+baltv[2:n,3]*rhobar;
baltv[2:n,m+3:2*m+2]=baltv[2:n,m+3:2*m+2].*seqa(2,1,n-1);
baltv[2:n,m+2]=(1-rhobar)*baltv[2:n,m+2].*seqa(2,1,n-1);
zrho=zrho-baltv[.,1:m+1]-baltv[.,m+2:2*m+2];

bnullv=ones(n,1).*bnull';
bnullv[2:n,1]=bnullv[2:n,1].*(1-1)+bnullv[2:n,3];
bnullv[2:n,m+3:2*m+2]=bnullv[2:n,m+3:2*m+2].*seqa(2,1,n-1);
bnullv[2:n,m+2]=zeros(n-1,1).*seqa(2,1,n-1);
zone=zone-bnullv[.,1:m+1]-bnullv[.,m+2:2*m+2];

elseif fdet==3;
st=seqa(2,1,n-1)'ones(n-1,1);           @ sum t @
st2=seqa(2,1,n-1)'seqa(2,1,n-1);        @ sum t-squared @
r1=eye(m+1);r1[1,1]=0;
b1=zeros(m+1,m+1);
b1[1,1]=1;
dn0=eye(2*(m+1));
dn0[1:m+1,1:m+1]=inv(om)+(n-1)*r1*inv(om)*r1;
dn0[1:m+1,m+2:2*(m+1)]=inv(om)+r1*inv(om)*r1*st+(n-1)*r1*inv(om)*b1;
dn0[m+2:2*(m+1),1:m+1]=dn0[1:m+1,m+2:2*(m+1)]';
dn0[m+2:2*(m+1),m+2:2*(m+1)]=inv(om)+r1*inv(om)*r1*st2
   +st*r1*inv(om)*b1+st*b1*inv(om)*r1+(n-1)*b1*inv(om)*b1;
sz1=zone[2:n,.]'ones(n-1,1);
sz2=zone[2:n,.]'seqa(2,1,n-1);
n1=(inv(om)*zone[1,.]'+r1*inv(om)*sz1);
n2=(inv(om)*zone[1,.]'+r1*inv(om)*sz2+b1*inv(om)*sz1);
bnull=inv(dn0[1:m+2,1:m+2])*(n1|n2[1,.]);

rr=eye(m+1);rr[1,1]=1-rhobar;
b1=zeros(m+1,m+1);
b1[1,1]=rhobar;
dn0=eye(2*(m+1));
dn0[1:m+1,1:m+1]=inv(om)+(n-1)*rr*inv(om)*rr;
dn0[1:m+1,m+2:2*(m+1)]=inv(om)+rr*inv(om)*rr*st+(n-1)*rr*inv(om)*b1;
dn0[m+2:2*(m+1),1:m+1]=dn0[1:m+1,m+2:2*(m+1)]';
dn0[m+2:2*(m+1),m+2:2*(m+1)]=inv(om)+rr*inv(om)*rr*st2
   +st*rr*inv(om)*b1+st*b1*inv(om)*rr+(n-1)*b1*inv(om)*b1;
sz1=zrho[2:n,.]'ones(n-1,1);
sz2=zrho[2:n,.]'seqa(2,1,n-1);
n1=(inv(om)*zrho[1,.]'+rr*inv(om)*sz1);
n2=(inv(om)*zrho[1,.]'+rr*inv(om)*sz2+b1*inv(om)*sz1);
balt=inv(dn0[1:m+2,1:m+2])*(n1|n2[1,.]);

baltv=ones(n,1).*balt';
baltv[2:n,1]=baltv[2:n,1].*(1-rhobar)+baltv[2:n,3]*rhobar;
baltv[2:n,m+2]=(1-rhobar)*baltv[2:n,m+2].*seqa(2,1,n-1);
baltv=baltv~zeros(n,m);
zrho=zrho-baltv[.,1:m+1]-baltv[.,m+2:2*m+2];

bnullv=ones(n,1).*bnull';
bnullv[2:n,1]=bnullv[2:n,1].*(1-1)+bnullv[2:n,3];
bnullv[2:n,m+2]=zeros(n-1,1).*seqa(2,1,n-1);
bnullv=bnullv~zeros(n,m);
zone=zone-bnullv[.,1:m+1]-bnullv[.,m+2:m+2:2*m+2];

endif;

{b,se,sig0,res0,r2}=var(zone,1,n,k,0);
{b,se,siga,resa,r2}=var(zrho,1,n,k,0);

@st=n*(sumc(diag(inv(sig0)*(siga-((m+rhobar)/(m+1))*sig0))));@
st=n*(sumc(diag(inv(sig0)*(siga)))-(m+rhobar));

retp(st,rsq,om,dlta);
endp;

/*
@ debug @
m=2;
fdet=3;
nobs=1000;
nmc=1000;

if fdet>1;
cbar=-13.5;
else;
cbar=-7;
endif;
c=0;
k=0;
r2=0.7;
rhobar=1+cbar/nobs;
rho=1+c/nobs;
lambda=eye(m+1);
lambda[1,2]=sqrt(r2);lambda[2,1]=lambda[1,2];
if m>1;
delt2=0.5;
lambda[1,2]=sqrt(r2-delt2^2);lambda[2,1]=lambda[1,2];
lambda[1,3]=(delt2);lambda[3,1]=lambda[1,3];
endif;
"true rsq  = ";;lambda[1,2:m+1]*lambda[2:m+1,1];
@rndseed 19936;@
a=zeros(nmc,1);cval=a;
imc=1; do until imc>rows(a);
sig9chol=chol(lambda)';
eps=sig9chol*rndn(rows(lambda),nobs);
eps=eps';
y=recserar(eps[.,1],0,rho);
x=eps[.,2:m+1];
{a[imc,1],rsq}=urstk(y,x,rhobar,fdet,k);
{cval[imc,1]}=cvurst(rsq,fdet);
imc=imc+1; endo;
" ";
#include c:\gauss\gtsp\pctile1a.prc;
output file=temp.out reset;
@pctile(a);@
" ";"size";
meanc(a.<cval);
{cv}=cvurst(r2,fdet);
meanc(a.<cv);
output off;
*/

